#include "raycaster.hpp"

static const int SCREEN_HEIGHT=720;
static const int SCREEN_WIDTH=1280;

Matrix MAP{
  {8,8,8,8,8,8,8,8,8},
  {8,0,2,0,0,0,0,0,8},
  {8,0,7,0,0,5,6,0,8},
  {8,0,0,0,0,0,0,0,8},
  {8,8,0,0,0,0,0,8,8},
  {8,0,0,1,3,4,0,0,8},
  {8,0,0,0,0,0,8,8,8},
  {8,0,0,0,0,0,0,0,8},
  {8,8,8,8,8,8,8,8,8}
};

int main() {
  using KB = sf::Keyboard;

  sf::RenderWindow window(sf::VideoMode(SCREEN_WIDTH, SCREEN_HEIGHT), "Zed's Ray Caster Game Thing");

  //ZED this should set with a function
  float player_x = matrix::width(MAP) / 2;
  float player_y = matrix::height(MAP) / 2;

  Raycaster rayview(window, MAP);

  rayview.position_camera(player_x, player_y);

  double moveSpeed = 0.1;
  double rotSpeed = 0.1;

  while(window.isOpen()) {
    rayview.render();
    // DRAW GUI
    window.display();

    if(KB::isKeyPressed(KB::W)) {
      rayview.run(moveSpeed, 1);
    } else if(KB::isKeyPressed(KB::S)) {
      rayview.run(moveSpeed, -1);
    }

    if(KB::isKeyPressed(KB::D)) {
      rayview.rotate(rotSpeed, -1);
    } else if(KB::isKeyPressed(KB::A)) {
      rayview.rotate(rotSpeed, 1);
    }

    sf::Event event;
    while(window.pollEvent(event)) {
      if(event.type == sf::Event::Closed) {
        window.close();
      }
    }
  }

  return 0;
}
